package com.hncy.service.wechat.applet.biz.tencent.map.core.response;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

/**
 * @Author: cs
 * @Date: 2022/1/18 16:45
 * 腾讯地图响应参数
 */
@Data
@ToString(callSuper = true)
@EqualsAndHashCode(callSuper = true)
public class TxMapResponse<T> extends TxMapBaseResponse implements TencentMapResponse {


    private static final String SUCCESS = "200";

    /**
     * 请求状态码(返回OK代表请求成功)
     */
    private String code;

    /**
     * 状态码的描述
     */
    private String message;

    /**
     * 返回的数据
     */
    private T data;

    @Override
    public boolean isSuccess() {
        return SUCCESS.equals(code);
    }

    public static<T> TxMapResponse<T> success() {
        TxMapResponse txMapResponse = new TxMapResponse();
        txMapResponse.code = "0";
        txMapResponse.message = "success";
        return txMapResponse;
    }

    public static<T> TxMapResponse<T> fail(String code, String message) {
        TxMapResponse txMapResponse = new TxMapResponse();
        txMapResponse.code = code;
        txMapResponse.message = message;
        return txMapResponse;
    }

    public static<T> TxMapResponse<T> success(T data) {
        TxMapResponse txMapResponse = new TxMapResponse();
        txMapResponse.code = SUCCESS;
        txMapResponse.data = data;
        txMapResponse.message = "success";
        return txMapResponse;
    }

    public static<T> TxMapResponse<T> success(String code, String message) {
        TxMapResponse txMapResponse = new TxMapResponse();
        txMapResponse.code = code;
        txMapResponse.message = message;
        return txMapResponse;
    }

    public static<T> TxMapResponse<T> success(String code, String message, T data) {
        TxMapResponse txMapResponse = new TxMapResponse();
        txMapResponse.code = code;
        txMapResponse.message = message;
        txMapResponse.data = data;
        return txMapResponse;
    }

}
