package com.hncy.service.wechat.applet.biz.tencent.map.service.geoCoder.impl;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import com.alibaba.fastjson.JSON;
import com.hncy.jackson.spring.boot.starter.core.JSONObject;
import com.hncy.service.wechat.applet.biz.constants.ARInspectionConstants;
import com.hncy.service.wechat.applet.biz.tencent.map.config.TxMapConfig;
import com.hncy.service.wechat.applet.biz.tencent.map.core.request.GeoCoderInterfaceParamRequest;
import com.hncy.service.wechat.applet.biz.tencent.map.core.request.GeoCoderRequest;
import com.hncy.service.wechat.applet.biz.tencent.map.core.response.TxMapResponse;
import com.hncy.service.wechat.applet.biz.tencent.map.service.geoCoder.GeoCoderInterface;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

/**
 * @Author: cs
 * @Date: 2022/1/19 8:55
 */
@Service
@Slf4j
public class GeoCoderInterfaceImpl implements GeoCoderInterface {

    @Autowired
    private TxMapConfig txMapConfig;

    private final String GEO_CODER= "/ws/geocoder/v1";

    private final String json = "json";

    private final String FUNCTION1 = "function1";
    private final String POLICY = "policy=2";

    @Override
    public TxMapResponse closeOrder(GeoCoderInterfaceParamRequest geoCoderInterfaceParamRequest) throws Exception {

        String host = txMapConfig.getUrl() + GEO_CODER;

        GeoCoderRequest geoCoderRequest = new GeoCoderRequest();
        geoCoderRequest.setKey(txMapConfig.getKey());
        StringBuffer buffer = new StringBuffer();
        StringBuffer location = buffer.append(geoCoderInterfaceParamRequest.getYCode()).append(",").append(geoCoderInterfaceParamRequest.getXCode());
        geoCoderRequest.setLocation(location.toString());
        geoCoderRequest.setGet_poi(ARInspectionConstants.ZERO);
        geoCoderRequest.setPoi_options(POLICY);
        geoCoderRequest.setOutput(json);
        geoCoderRequest.setCallback(FUNCTION1);
        String geoCoderRequestToJSONString = JSONObject.getInstance().toJSONString(geoCoderRequest);

        Map<String,String> map = new HashMap<>();
        map.put("Content-Type", "application/json;charset=UTF-8");
        map.put("Connection", "keep-alive");

        HttpResponse httpRequest = HttpRequest.get(host).addHeaders(map).body(geoCoderRequestToJSONString).setReadTimeout(3000).setConnectionTimeout(3000).execute();
        String bodyToJSON = JSONObject.getInstance().toJSONString(httpRequest.body());
        Map<String, Object> jsonToMap = (Map) JSON.parse(bodyToJSON);
        Integer status = Integer.parseInt(jsonToMap.get("status").toString());
        Map<String, String> result = (Map) JSON.parse(jsonToMap.get("result").toString());
        if(0 == status) {
            String address = result.get("address");
            return TxMapResponse.success(address);
        }else {
            return TxMapResponse.fail(jsonToMap.get("status").toString(),jsonToMap.get("message").toString());
        }
    }
}
