package com.hncy;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import com.alibaba.fastjson.JSON;
import com.hncy.jackson.spring.boot.starter.core.JSONObject;
import com.hncy.service.wechat.applet.biz.mapper.CityGridMapper;
import com.hncy.service.wechat.applet.biz.mapper.CommunityGridMapper;
import com.hncy.service.wechat.applet.biz.mapper.DyGridMapper;
import com.hncy.service.wechat.applet.biz.mapper.StreetGridMapper;
import com.hncy.service.wechat.applet.biz.tencent.map.core.request.GeoCoderInterfaceParamRequest;
import com.hncy.service.wechat.applet.biz.tencent.map.core.request.GeoCoderRequest;
import com.hncy.service.wechat.applet.biz.utils.CoordTransform;
import com.hncy.service.wechat.applet.biz.vo.ComponentLocation;
import org.springframework.beans.factory.annotation.Autowired;

import java.sql.SQLOutput;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/*@SpringBootTest(classes = ArxjWxAppletApplication.class)
@RunWith(SpringRunner.class)*/
public class Test {

    @Autowired
    private CommunityGridMapper communityGridMapper;
    @Autowired
    private StreetGridMapper streetGridMapper;
    @Autowired
    private CityGridMapper cityGridMapper;
    @Autowired
    private DyGridMapper dyGridMapper;

    private final String GEO_CODER= "/ws/geocoder/v1";

    @org.junit.Test
    public void ToBaiDu() {
        double x = 103.84864995148352;
        double y = 30.05750685572187;
        double[] doubles = CoordTransform.transformWGS84ToBD09(x, y);
        String WGS84Lng = null;
        String WGS84Lat = null;
        for(int i = 0; i < doubles.length; i++) {
             WGS84Lng = String.valueOf(doubles[0]);
             WGS84Lat = String.valueOf(doubles[1]);
        }
        System.out.println("84转百度坐标系的经度:  "+WGS84Lng+"  以及纬度:  "+WGS84Lat);
    }

    @org.junit.Test
    public void componentLocation() {
        String xCode = "103.83023927441";
        String yCode = "30.055237650225";
        List<ComponentLocation> componentLocationList = new ArrayList<>();
        ComponentLocation componentLocation = new ComponentLocation();

        String districtCode = cityGridMapper.selectDistrictCode(xCode,yCode);
        System.out.println(districtCode);
        String streetCode = streetGridMapper.selectStreetCode(xCode,yCode);
        String communityCode = communityGridMapper.selectCommunityCode(xCode,yCode);
        String dyGridCode = dyGridMapper.selectDyGridCode(xCode,yCode);

        componentLocation.setDistrictCode(districtCode);
        componentLocation.setStreetCode(streetCode);
        componentLocation.setCommunityCode(communityCode);
        componentLocation.setDyGridCode(dyGridCode);
        componentLocationList.add(componentLocation);
        System.out.println(componentLocationList);
    }

    @org.junit.Test
    public void JQScore() {
        double csCode = 412;
        double fsCode = 264;
        double JQscore = 0;
        JQscore = (csCode/5)*0.3 + (fsCode/3)*0.7;
        System.out.println(JQscore);
    }

    @org.junit.Test
    public void geoTest() throws Exception {
        String xCode = "104.07376798060986";
        String yCode = "30.55524478797796";
        String WGS84Lng = null;
        String WGS84Lat = null;
        //百度转gcj-02
        double[] doubles = CoordTransform.transformBD09ToGCJ02(Double.valueOf(xCode), Double.valueOf(yCode));
        for(int i = 0; i < doubles.length; i++) {
             WGS84Lng = String.valueOf(doubles[0]);
             WGS84Lat = String.valueOf(doubles[1]);
        }

        GeoCoderInterfaceParamRequest geoCoderInterfaceParamRequest = new GeoCoderInterfaceParamRequest();
        geoCoderInterfaceParamRequest.setXCode(WGS84Lng);
        geoCoderInterfaceParamRequest.setYCode(WGS84Lat);

        String host = "https://apis.map.qq.com" + GEO_CODER;

        GeoCoderRequest geoCoderRequest = new GeoCoderRequest();
        geoCoderRequest.setKey("QP4BZ-GQQLU-HDTVE-BJKQA-YDXEF-73B65");
        StringBuffer buffer = new StringBuffer();
        StringBuffer location = buffer.append(geoCoderInterfaceParamRequest.getYCode()).append(",").append(geoCoderInterfaceParamRequest.getXCode());
        geoCoderRequest.setLocation(location.toString());
        geoCoderRequest.setGet_poi("0");
        geoCoderRequest.setPoi_options("policy=2");
        geoCoderRequest.setOutput("json");
        geoCoderRequest.setCallback("function1");
        String geoCoderRequestToJSONString = JSONObject.getInstance().toJSONString(geoCoderRequest);


        Map<String,String> map = new HashMap<>();
        map.put("Content-Type", "application/json;charset=UTF-8");
        map.put("Connection", "keep-alive");

        HttpResponse httpRequest = HttpRequest.get(host).addHeaders(map).body(geoCoderRequestToJSONString).setReadTimeout(3000).setConnectionTimeout(3000).execute();
        String bodyToJSON = JSONObject.getInstance().toJSONString(httpRequest.body());
        System.out.println(bodyToJSON);

        Map<String, Object> jsonToMap = (Map) JSON.parse(bodyToJSON);
        Integer status = Integer.parseInt(jsonToMap.get("status").toString());
        Map<String, String> result = (Map) JSON.parse(jsonToMap.get("result").toString());
        if(0 == status) {
            String address = result.get("address");
            System.out.println(address);
        }else {
            System.out.println(jsonToMap.get("status"));
        }
    }

    /**
     * @Author: cs
     * @Date: 2022/2/10 15:18
     *
     * 一个数组有2n个元素，其中有n个奇数、n个偶数，数组无序，写一个算法使得奇数位置放置奇数，偶数位置放置偶数
     */
    @org.junit.Test
    public void sort() {
        int[] array = new int[]{1,2,1,2,1,1,1,2,2,2,2,1,1,2,2,2,2,2,2,2};
        for (int i=0; i < array.length-1; i++) {
            int j = i+1;
            if(i % 2 != 0) { //奇数位置
                if(array[i] % 2 == 1) { //不是偶数
                    while (j< array.length-1) {
                        if(j % 2 == 0 && array[j] % 2 == 0) {
                            j++;
                        }else {
                            //如果是偶数则继续往后遍历
                            if(array[j] % 2 == 1) {
                                j++;
                            }else {
                                break;//找到奇数
                            }
                        }
                    }
                    int temp = array[j];
                    array[j] = array[i];
                    array[i] = temp;
                }
            }else { //偶数位置
                if(array[i] % 2 == 0) {//不是奇数
                    while (j< array.length-1) {
                        //奇数位置放置的是奇数则往后遍历
                        if(j % 2 != 0 && array[j] % 2 == 1) {
                            j++;
                        }else {
                            //如果是偶数则继续往后遍历
                            if(array[j] % 2 == 0) {
                                j++;
                            }else {
                                break;//找到奇数
                            }
                        }
                    }
                    int temp = array[j];
                    array[j] = array[i];
                    array[i] = temp;
                }
            }
        }
        for (int i : array) {
            System.out.println(i);
        }
    }


    @org.junit.Test
    public void string() {
/*        String A = "aaabbb";
        String B = new String("aaa")+new String("bbb");
        String C = B.intern();
        System.out.println(A==B); //false
        System.out.println(A==C); //true
*/
        String B = new String("aaa")+new String("bbb");
        String C = B.intern();
        String A = "aaabbb";
        System.out.println(A==B);
        System.out.println(A==C);
        System.out.println(A.equals(B));
        System.out.println(A.equals(C));
    }

}
